CF2B The least round way(dp+记录路径)
2 seconds
64 megabytes
standard input
standard output
There is a square matrix n × n, consisting of non-negative integer numbers. You should find such a way on it that
- starts in the upper left cell of the matrix;
- each following cell is to the right or down from the current cell;
- the way ends in the bottom right cell.
Moreover, if we multiply together all the numbers along the way, the result should be the least "round". In other words, it should end in the least possible number of zeros.
The first line contains an integer number n (2 ≤ n ≤ 1000), n is the size of the matrix. Then follow n lines containing the matrix elements (non-negative integer numbers not exceeding 109).
In the first line print the least number of trailing zeros. In the second line print the correspondent way itself.
3
1 2 3
4 5 6
7 8 9
0
DDRR
题意:给你一个n*n的矩阵 只能向下或者向右 问你从左上角走到左下角 你走过路径上数字的乘积尾部0个数最少的走法
思路:我们知道只有2和5的组合可以让尾部为0 所以我们可以预处理每个数字有多少个2和5 然后很容易得出方程dp[i][j][0/1]=min(dp[i-1][j][0/1],dp[i][j-1][0/1])+a[i][j][0/1]
值得注意的是 如果其中有出现0这个数字 那么就表示 只要经过这个点 那么尾部0的个数必然是1 那么答案就只能在0或者1中产生
#include<cstdio>
#include<cstring>
#include<algorithm>
#include<iostream>
#include<string>
#include<vector>
#include<stack>
#include<bitset>
#include<cstdlib>
#include<cmath>
#include<set>
#include<list>
#include<deque>
#include<map>
#include<time.h>
#include<queue>
#define ll long long int
using namespace std;
inline ll gcd(ll a,ll b){return b?gcd(b,a%b):a;}
inline ll lcm(ll a,ll b){return a/gcd(a,b)*b;}
int moth[]={,,,,,,,,,,,,};
int dir[][]={, ,, ,-, ,,-};
int dirs[][]={, ,, ,-, ,,-, -,- ,-, ,,- ,,};
const int inf=0x3f3f3f3f;
const ll mod=1e9+;
int dp[][][]; //0表示2的个数 1表示5的个数
int a[][]; //存矩阵
bool f=;
struct node{
int x;int y;
};
node path2[][]; //记录2的个数最少时的路径
node path1[][]; //记录5的个数最少时的路径
node ans[];
int cnt=;
void output1(node x){ //记录答案
if(x.x==&&x.y==) return ;
node t; t=path1[x.x][x.y];
output1(t);
ans[++cnt]=x;
}
void output2(node x){ //记录答案
if(x.x==&&x.y==) return ;
node t; t=path2[x.x][x.y];
output2(t);
ans[++cnt]=x;
}
int main(){
ios::sync_with_stdio(false);
int n;
cin>>n;
int posx,posy;
for(int i=;i<=n;i++)
for(int j=;j<=n;j++){
cin>>a[i][j];
int t=a[i][j];
if(t==){ //一但出现零我们需要标记一下
f=;
dp[i][j][]++;
dp[i][j][]++;
posx=i;
posy=j;
continue;
}
while(){ //统计2 和 5 的个数
if(t%==){
t/=;
dp[i][j][]++;
}else if(t%==){
t/=;
dp[i][j][]++;
}else{
break;
}
}
}
for(int i=;i<=n;i++){ // 预处理边界
dp[][i][]+=dp[][i-][];
dp[][i][]+=dp[][i-][];
node t; t.x=; t.y=i-;
path1[][i]=path2[][i]=t;
dp[i][][]+=dp[i-][][];
dp[i][][]+=dp[i-][][];
t.x=i-; t.y=;
path1[i][]=path2[i][]=t;
}
path1[][].x=path2[][].x=;
path1[][].y=path2[][].y=;
for(int i=;i<=n;i++)
for(int j=;j<=n;j++){ //递推
if(dp[i-][j][]<dp[i][j-][]){
dp[i][j][]=dp[i-][j][]+dp[i][j][];
node temp; temp.x=i-; temp.y=j;
path1[i][j]=temp;
}else{
dp[i][j][]=dp[i][j-][]+dp[i][j][];
node temp; temp.x=i; temp.y=j-;
path1[i][j]=temp;
}
}
for(int i=;i<=n;i++)
for(int j=;j<=n;j++){ //递推
if(dp[i-][j][]<dp[i][j-][]){
dp[i][j][]=dp[i-][j][]+dp[i][j][];
node temp; temp.x=i-; temp.y=j;
path2[i][j]=temp;
}else{
dp[i][j][]=dp[i][j-][]+dp[i][j][];
node temp; temp.x=i; temp.y=j-;
path2[i][j]=temp;
}
}
int minn=min(dp[n][n][],dp[n][n][]);
if(minn>&&f){ //表示尾部零最小的个数就是1 那么我们就可以直接输出
cout<<""<<endl;
for(int i=;i<posx;i++)
cout<<"D";
for(int j=;j<posy;j++)
cout<<"R";
for(int i=posx;i<n;i++)
cout<<"D";
for(int j=posy;j<n;j++)
cout<<"R";
cout<<endl;
return ;
}
cout<<minn<<endl;
node e; e.x=n; e.y=n;
if(dp[n][n][]<dp[n][n][])
output1(e);
else{
output2(e);
}
for(int i=;i<=cnt;i++){
if(ans[i].x==ans[i-].x+)
cout<<"D";
else
cout<<"R";
}
cout<<endl;
return ;
}
CF2B The least round way(dp+记录路径)的更多相关文章
- PAT L3-001 凑零钱(01背包dp记录路径)
韩梅梅喜欢满宇宙到处逛街.现在她逛到了一家火星店里,发现这家店有个特别的规矩:你可以用任何星球的硬币付钱,但是绝不找零,当然也不能欠债.韩梅梅手边有104枚来自各个星球的硬币,需要请你帮她盘算一下,是 ...
- Codeforces Round #436 (Div. 2) E. Fire(dp 记录路径)
E. Fire time limit per test 2 seconds memory limit per test 256 megabytes input standard input outpu ...
- hdu 1074(状态压缩dp+记录路径)
题意:给了n个家庭作业,然后给了每个家庭作业的完成期限和花费的实践,如果完成时间超过了期限,那么就要扣除分数,然后让你找出一个最优方案使扣除的分数最少,当存在多种方案时,输出字典序最小的那种,因为题意 ...
- [CF2B] The least round way - dp
给定由非负整数组成的n×n 的正方形矩阵,你需要寻找一条路径: 以左上角为起点 每次只能向右或向下走 以右下角为终点 并且,如果我们把沿路遇到的数进行相乘,积应当是最小"round" ...
- uva 10453 - Make Palindrome(dp, 记录路径)
题目 题意: 给一个字符串 ,判断最少插入多少个字符 使字符串成为回文串, 并输出回文串. 思路:先用dp判断需要个数, 再递归输出路径. #include <iostream> #inc ...
- codeforces 1272F dp+记录路径
题意 给出两个括号序列 \(S\) 和 \(T\),让你构造一个最短的合法括号序列使 \(S\) 和 \(T\) 是它的子序列. 分析 设 \(dp[i][j][k]\) 为这个最短的合法括号序列的前 ...
- POJ 题目1141 Brackets Sequence(区间DP记录路径)
Brackets Sequence Time Limit: 1000MS Memory Limit: 65536K Total Submissions: 27793 Accepted: 788 ...
- POJ 2111 DP+记录路径
题意: 思路: 类似滑雪 //By SiriusRen #include <cstdio> #include <cstring> #include <algorithm& ...
- hdu1074 状压DP、栈实现记录路径
题意:给了几门学科作业.它们的截止提交期限(天数).它们的需要完成的时间(天数),每项作业在截止日期后每拖延一天扣一学分,算最少扣的学分和其完成顺序. 一开始做的时候,只是听说过状态压缩这个神奇的东西 ...
随机推荐
- centos7个人shell编写环境
一.配置存放文件/root/wang 存放常用的文件/root/wang/shell 存放练习的shell文件/root/wang/succeed_shell 存放有用shell文件/root/bak ...
- c/c++ 多线程 利用条件变量实现线程安全的队列
多线程 利用条件变量实现线程安全的队列 背景:标准STL库的队列queue是线程不安全的. 利用条件变量(Condition variable)简单实现一个线程安全的队列. 代码: #include ...
- 虚拟机 与 host主机,无法ping通的问题
这个写的比较简单,先做以下记录 centos虚拟机安装到别的电脑上,因为linux中的程序需要向外有网络互通,所以需要重新设置ip 通过 ifconfig eth4 192.168.0.20 bro ...
- LeetCode算法题-Longest Uncommon Subsequence I(Java实现)
这是悦乐书的第252次更新,第265篇原创 01 看题和准备 今天介绍的是LeetCode算法题中Easy级别的第119题(顺位题号是521).给定一组两个字符串,您需要找到这组两个字符串中最长的不同 ...
- DB2 因版本问题 Reorg 出错 解决办法
call Sysproc.admin_cmd('REORG TABLE MY_TABLE_NAME');
- Redis管道和发布订阅
管道:原子性执行命令 ''' redis-py默认在执行每次请求都会创建(连接池申请连接)和断开(归还连接池)一次连接操作, 如果想要在一次请求中指定多个命令,则可以使用pipline实现一次请求指定 ...
- TCP/IP及内核参数优化调优
Linux下TCP/IP及内核参数优化有多种方式,参数配置得当可以大大提高系统的性能,也可以根据特定场景进行专门的优化,如TIME_WAIT过高,DDOS攻击等等.如下配置是写在sysctl.conf ...
- MySQL之初识数据库
一 数据库管理软件的由来 基于我们之前所学,数据要想永久保存,都是保存于文件中,毫无疑问,一个文件仅仅只能存在于某一台机器上. 如果我们暂且忽略直接基于文件来存取数据的效率问题,并且假设程序所有的组件 ...
- go笔记-熔断器
参考: https://studygolang.com/articles/13254 区别:(限速器 VS 熔断器) 限速器(limiter)可以限制接口自身被调的频率 熔断器可监控所调用的服务的失败 ...
- 为什么很多IT公司不喜欢进过培训机构的人呢?
转载原文链接:https://www.cnblogs.com/alex3714/p/9105765.html 这几天在知乎看到一个问题“为什么很多IT公司不喜欢进过培训机构的人呢?” 身为老男孩的教学 ...